-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.Game.release>=9 then
lib.classes["DEMONHUNTER"] = {}
local t,s,n
lib.classpreload["DEMONHUNTER"] = function()
	lib.InitPower()
	lib.InitCleave()
	cfg.cleave_threshold=3
end
-- HAVOC SPEC
lib.classes["DEMONHUNTER"][1] = function()
	--lib.SetPower("Fury")
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	--lib.LoadSwingTimer()
	cfg.talents={
		["Blind Fury"]=IsPlayerSpell(203550),
		["Demonic Appetite"]=IsPlayerSpell(206478),
		["Felblade"]=IsPlayerSpell(232893),
		["Insatiable Hunger"]=IsPlayerSpell(258876),
		["Demon Blades"]=IsPlayerSpell(203555),
		["Immolation Aura"]=IsPlayerSpell(258920),
		["Trail of Ruin"]=IsPlayerSpell(258881),
		["Fel Mastery"]=IsPlayerSpell(192939),
		["Fel Barrage"]=IsPlayerSpell(258925),
		["Soul Rending"]=IsPlayerSpell(204909),
		["Desperate Instincts"]=IsPlayerSpell(205411),
		["Netherwalk"]=IsPlayerSpell(196555),
		["Cycle of Hatred"]=IsPlayerSpell(258887),
		["First Blood"]=IsPlayerSpell(206416),
		["Dark Slash"]=IsPlayerSpell(258860),
		["Unleashed Power"]=IsPlayerSpell(206477),
		["Master of the Glaive"]=IsPlayerSpell(203556),
		["Fel Eruption"]=IsPlayerSpell(211881),
		["Demonic"]=IsPlayerSpell(213410),
		["Momentum"]=IsPlayerSpell(206476),
		--["Nemesis"]=IsPlayerSpell(206491),
		["Unbound Chaos"]=IsPlayerSpell(347461),
		["Glaive Tempest"]=IsPlayerSpell(342817),
		["Essence Break"]=IsPlayerSpell(258860),
		
	}
	if cfg.talents["Essence Break"] then
		lib.AddSpell("Essence Break",{258860})
	end
	if cfg.talents["Unbound Chaos"] then
		lib.AddAura("Unbound Chaos",347462,"buff","player")
	end
	
	if cfg.talents["Glaive Tempest"] then
		lib.AddSpell("Glaive Tempest",{342817})
		lib.AddCleaveSpell("Glaive Tempest",nil,{342857})
	end
	lib.AddSpell("Blade Dance",{210152,188499},true)
	lib.AddCleaveSpell("Blade Dance",nil,{188499,199552,200685,210152,210153,210155})
	lib.AddSpell("Blur",{198589})
	lib.AddSpell("Chaos Strike",{201427,162794})
	lib.AddSpell("Dark Slash",{258860})
	lib.AddSpell("Darkness",{196718})
	if not cfg.talents["Demon Blades"] then
		lib.AddSpell("Demon's Bite",{162243})
	end
	lib.AddSpell("Eye Beam",{198013},nil,nil,true)
	--lib.OnSpellCast("Eye Beam",function()
	--[[lib.SetSpellFunction("Eye Beam","OnCast",function()
		local spell="Eye Beam"
		print(GetTime().." Eye Beam "..lib.GetSpellCD(198013,true))
		print(GetSpellCooldown(198013))
		if cfg.Channeling.name then
			print("Channeling "..cfg.Channeling.endTime-cfg.Channeling.startTime)
		print(cfg.spells[spell].start.." "..cfg.spells[spell].cd.." "..cfg.spells[spell].tl.." "..cfg.spells[spell].fullcd)
		end
		print("---")
		--print(GetTime().." Eye Beam "..{GetSpellCooldown(198013)})
	end)]]
	lib.AddCleaveSpell("Eye Beam",nil,{198030})
	lib.AddSpell("Fel Barrage",{258925})
	--lib.AddCleaveSpell("Fel Barrage")
	lib.AddSpell("Fel Eruption",{211881},"target")
	lib.AddSpell("Fel Rush",{195072})
	--lib.AddCleaveSpell("Fel Rush")
	lib.AddSpell("Felblade",{232893})
	lib.AddSpell("Metamorphosis",{191427})
	lib.AddAura("Metamorphosis",162264,"buff","player")
	--lib.AddSpell("Nemesis",{206491},"target")
	lib.AddSpell("Throw Glaive",{185123})
	lib.AddSpell("Vengeful Retreat",{198793})
	lib.AddAura("Blur",212800,"buff","player")
	lib.AddAura("Momentum",208628,"buff","player")
--	lib.AddAura("Nemesis2",208579,"buff","player")
--	lib.AddAura("Prepared",203650,"buff","player")

	lib.SetAuraFunction("Metamorphosis","OnApply",function()
		lib.ReloadSpell("Chaos Strike",{201427,162794})
		lib.ReloadSpell("Blade Dance",{210152,188499},true)
		--lib.AddCleaveSpell("Blade Dance",nil, )
	end)
	lib.SetAuraFunction("Metamorphosis","OnFade",function()
		lib.ReloadSpell("Chaos Strike",{162794,201427})
		lib.ReloadSpell("Blade Dance",{188499,210152},true)
		--lib.AddCleaveSpell("Blade Dance")
	end)

	lib.SetTrackAura({"Unbound Chaos","Momentum"})
	lib.AddTracking("Metamorphosis",{255,0,255})
	

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Consume Magic")
	if cfg.talents["Momentum"] then
		table.insert(cfg.plistdps,"Vengeful Retreat")
		table.insert(cfg.plistdps,"Fel Rush_max")
	end
	if cfg.talents["Fel Barrage"] then
		table.insert(cfg.plistdps,"Fel Barrage")
	end
	if cfg.talents["Unbound Chaos"] then
		table.insert(cfg.plistdps,"Fel Rush_Unbound Chaos")
	end
	table.insert(cfg.plistdps,"The Hunt")
	table.insert(cfg.plistdps,"Metamorphosis_noEye Beam")
	if cfg.talents["Glaive Tempest"] then
		table.insert(cfg.plistdps,"Glaive Tempest")
	end
	table.insert(cfg.plistdps,"Immolation Aura")
	if cfg.talents["Felblade"] then
		table.insert(cfg.plistdps,"Felblade")
	end
	if cfg.talents["Essence Break"] then
		table.insert(cfg.plistdps,"Essence Break")
	end
	table.insert(cfg.plistdps,"Eye Beam")
	table.insert(cfg.plistdps,"Blade Dance_aoe")
	table.insert(cfg.plistdps,"Immolation Aura")
	if cfg.talents["First Blood"] then
		table.insert(cfg.plistdps,"Blade Dance")
	end
	table.insert(cfg.plistdps,"Blade Dance_aoe")
	table.insert(cfg.plistdps,"Chaos Strike")
	if cfg.talents["Demon Blades"] then
		table.insert(cfg.plistdps,"Fel Rush")
		table.insert(cfg.plistdps,"Throw Glaive")
	else
		table.insert(cfg.plistdps,"Demon's Bite")
	end
	table.insert(cfg.plistdps,"end")

	cfg.plistaoe = nil
	cfg.plist=cfg.plistdps

	cfg.case = {
		
		["Fel Rush_Unbound Chaos"] = function ()
			if lib.GetAura({"Unbound Chaos"})>lib.GetSpellCD("Fel Rush") then
				return lib.SimpleCDCheck("Fel Rush")
			end
			return nil
		end,
		["Chaos Strike"] = function ()
			--if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Chaos Strike",true)+1*cfg.gcd) then return nil end
			if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Eye Beam")) then return nil end
			if cfg.noaoe==false and cfg.cleave_targets>=cfg.cleave_threshold then
				--if lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)+1*cfg.gcd) then return nil end
				if (lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
					cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance"))) then
					--print ("Waiting for "..(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance")).." "..cfg.Power.now);
					return nil end
			end
			--[[if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Chaos Strike",true)+2*cfg.gcd) and cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Eye Beam")) then
				return nil
			end
			if cfg.noaoe==false and cfg.cleave_targets>=cfg.cleave_threshold and lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)-2*cfg.gcd) and cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance")) then
				return nil
			end]]
			
			return lib.SimpleCDCheck("Chaos Strike")
		end,
		["Vengeful Retreat"] = function()
			if lib.GetAura({"Prepared"}) > 0 then return nil end
			-- if lib.GetAura({"Prepared"}) > 0 or lib.GetSpellCharges("Fel Rush") == 0 then return nil end
			return lib.SimpleCDCheck("Vengeful Retreat")
		end,
		["Metamorphosis_noEye Beam"] = function()
			if cfg.Power.now<40 then return nil end
			if lib.GetSpellCD("Eye Beam",true)<=lib.GetSpellCD("Metamorphosis") then return nil end
			return lib.SimpleCDCheck("Metamorphosis")
		end,
		["Fel Rush_max"] = function()
			if lib.GetSpellCD("Fel Rush", false, 1) > lib.GetSpellCD("Vengeful Retreat") then return nil end
			if lib.GetAura({"Prepared"}) == 0 or
			lib.GetSpellCharges("Fel Rush") == 2 or
			(lib.GetSpellCharges("Fel Rush") == 1 and lib.GetSpellCD("Fel Rush", false, 2) < 3) then
				return lib.SimpleCDCheck("Fel Rush")
			end
			return nil
		end,
		["Dark Slash"] = function()
			if cfg.Power.now < 80 then return nil end
			return lib.SimpleCDCheck("Dark Slash")
		end,
		["Blade Dance_aoe"] = function()
			if cfg.cleave_targets < 3 then return nil end
			return lib.SimpleCDCheck("Blade Dance")
		end,
		["Felblade"] = function()
			if cfg.Power.now >= 80 then return nil end
			return lib.SimpleCDCheck("Felblade")
		end,
		["Fel Rush"] = function()
			if lib.GetSpellCD("Fel Rush", false, 1) > lib.GetSpellCD("Vengeful Retreat") then return nil end
			return lib.SimpleCDCheck("Fel Rush")
		end,
	}
	lib.AddRangeCheck({
		{"Chaos Strike",nil},
		{"Kick",{0,0,1,1}},
		{"Throw Glaive",{0,1,0,1}},
	})
	return true
end

-- VENGEANCE SPEC
lib.classes["DEMONHUNTER"][2] = function()
	--cfg.MonitorSpells=true
	--lib.SetPower("Pain")
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	cfg.talents={
		["Abyssal Strike"]=IsPlayerSpell(207550),
		["Agonizing Flames"]=IsPlayerSpell(207548),
		["Razor Spikes"]=IsPlayerSpell(209400),
		["Feast of Souls"]=IsPlayerSpell(207697),
		["Fallout"]=IsPlayerSpell(227174),
		["Burning Alive"]=IsPlayerSpell(207739),
		["Flame Crash"]=IsPlayerSpell(227322),
		["Charred Flesh"]=IsPlayerSpell(264002),
		["Felblade"]=IsPlayerSpell(232893),
		["Soul Rending"]=IsPlayerSpell(217996),
		["Feed the Demon"]=IsPlayerSpell(218612),
		["Fracture"]=IsPlayerSpell(263642),
		["Concentrated Sigils"]=IsPlayerSpell(207666),
		["Quickened Sigils"]=IsPlayerSpell(209281),
		["Sigil of Chains"]=IsPlayerSpell(202138),
		["Gluttony"]=IsPlayerSpell(264004),
		["Spirit Bomb"]=IsPlayerSpell(247454),
		["Fel Devastation"]=IsPlayerSpell(212084),
		["Last Resort"]=IsPlayerSpell(209258),
		["Void Reaver"]=IsPlayerSpell(268175),
		["Soul Barrier"]=IsPlayerSpell(263648),
	}

	--lib.AddSpell("Consume Magic",{278326})
	lib.AddSpell("Demon Spikes",{203720})
	lib.AddSpell("Fel Devastation",{212084},nil,nil,true)
	lib.AddSpell("Felblade",{232893})
	lib.AddSpell("Fiery Brand",{204021})
	lib.AddSpell("Fracture",{263642})
	--lib.AddSpell("Immolation Aura",{178740},true)
	lib.AddSpell("Infernal Strike",{189110})
	lib.AddSpell("Shear",{203782})
	lib.AddSpell("Sigil of Flame",{204596})
	lib.AddSpell("Soul Barrier",{227225},true)
	lib.AddSpell("Soul Cleave",{228477})
	lib.AddCleaveSpell("Soul Cleave") --,nil,{228478}
	if cfg.talents["Spirit Bomb"] then
		lib.AddSpell("Spirit Bomb",{247454})
		lib.AddCleaveSpell("Spirit Bomb",nil,{247455})
		lib.AddAura("Spirit Bomb",224509,"debuff","target")
	end
	lib.AddSpell("Throw Glaive",{204157})

	-- lib.AddCleaveSpell("Soul Cleave",nil,{228478})

	lib.AddAura("Demon Spikes",203819,"buff","player")
	lib.AddAura("Fiery Brand",207744,"debuff","target")
	lib.AddAura("Sigil of Flame",204598,"debuff","target")
	lib.AddAura("Soul Fragments",203981,"buff","player")
	 --Frailty

	lib.SetTrackAura("Soul Fragments")

	lib.SaveSpell(189111) --For Casts

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Consume Magic")
	table.insert(cfg.plistdps,"Infernal Strike")
	table.insert(cfg.plistdps,"The Hunt")
	table.insert(cfg.plistdps,"Fiery Brand")
	if cfg.talents["Spirit Bomb"] then
		table.insert(cfg.plistdps,"Spirit Bomb_4")
	end
	table.insert(cfg.plistdps,"Fel Devastation")
	table.insert(cfg.plistdps,"Soul Cleave")
	if cfg.talents["Fracture"] then
		table.insert(cfg.plistdps,"Fracture")
	end
	table.insert(cfg.plistdps,"Immolation Aura")
	table.insert(cfg.plistdps,"Sigil of Flame")
	
--	table.insert(cfg.plistdps,"Demon Spikes")

	if not cfg.talents["Fracture"] then
		table.insert(cfg.plistdps,"Shear")
	end
	table.insert(cfg.plistdps,"Throw Glaive")
	table.insert(cfg.plistdps,"end")

	cfg.plistaoe = nil
	cfg.plist=cfg.plistdps


	cfg.case = {
		["Infernal Strike"] = function()
			return lib.SimpleCDCheck("Infernal Strike",lib.GetSpellCD("Infernal Strike",nil,lib.GetSpellMaxCharges("Infernal Strike")))
		end,
		["Spirit Bomb_4"] = function()
			if lib.GetAuraStacks("Soul Fragments")>=4 or (lib.GetSpellLastCast("Fracture")<cfg.gcd and lib.GetAuraStacks("Soul Fragments")>=2) then
				return lib.SimpleCDCheck("Spirit Bomb")
			end
			return nil
		end,
		["Soul Cleave"] = function()
			if lib.GetSpellLastCast("Fracture")<cfg.gcd then return nil end
			if lib.GetAuraStacks("Soul Fragments")==0 then --cfg.Power.max - cfg.Power.now < 25 and
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,
		["Fracture"] = function()
			--if cfg.Power.max - cfg.Power.now < 25 then return nil end
			--if lib.GetAuraStacks("Soul Fragments") > 3 then return nil end
			return lib.SimpleCDCheck("Fracture")
		end,
		["Demon Spikes"] = function()
			return lib.SimpleCDCheck("Demon Spikes",lib.GetSpellCD("Demon Spikes",nil,lib.GetSpellMaxCharges("Demon Spikes")))
		end,
		--[[["Immolation Aura"] = function()
			if cfg.talents["Fallout"] and lib.GetAuraStacks("Soul Fragments") >= 4 then return nil end
			if cfg.Power.max - cfg.Power.now < 20 then return nil end
			return lib.SimpleCDCheck("Immolation Aura")
		end,]]
		--[[["Spirit Bomb"] = function()
			if lib.GetAuraStacks("Soul Fragments") == 0 and cfg.Power.max - cfg.Power.now < 20 then return nil end
			return lib.SimpleCDCheck("Spirit Bomb")
		end,
		["Soul Cleave_SB"] = function()
			if lib.GetAuraStacks("Soul Fragments") < 2 and cfg.Power.max - cfg.Power.now > 20 then return nil end
			return lib.SimpleCDCheck("Soul Cleave")
		end,
		["Shear"] = function()
			if cfg.Power.max - cfg.Power.now < 15 then return nil end
			if lib.GetAuraStacks("Soul Fragments") >= 4 then return nil end
			return lib.SimpleCDCheck("Shear")
		end,]]
		--[[["Infernal Strike"] = function()
			if lib.GetSpellCharges("Infernal Strike") <= 1 then return end
			return lib.SimpleCDCheck("Infernal Strike")
		end,]]
	}
	lib.AddRangeCheck({
		{"Shear",nil},
		{"Felblade",{1,1,0,1}},
		{"Kick",{0,0,1,1}},
		{"Throw Glaive",{0,1,0,1}},
	})
	return true
end

lib.classpostload["DEMONHUNTER"] = function()
	lib.AddSpell("The Hunt",{323639})
	cfg.case["The Hunt"] = function ()
			if lib.SpellCasting("The Hunt") then return nil end
			return lib.SimpleCDCheck("The Hunt")
	end
	lib.SetInterrupt("Kick",{183752})
	lib.AddDispellTarget("Consume Magic",{278326},{"Magic"})
	lib.AddSpell("Immolation Aura",{258920},"player")
	lib.AddCleaveSpell("Immolation Aura",nil,{258922})
	lib.AddTracking("Immolation Aura",{255,255,0})
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Consume Magic")
		-- lib.CDadd("Fel Eruption")
		--lib.CDadd("Throw Glaive")
		--lib.CDadd("Blur")
		--lib.CDAddCleave("Spirit Bomb",nil,218677)
		lib.CDadd("Fiery Brand")
		lib.CDadd("Demon Spikes")
		lib.CDadd("Soul Barrier")
		
		lib.CDadd("Metamorphosis")
		--lib.CDadd("Nemesis")
		--lib.CDadd("Eye Beam")
		--lib.CDAddCleave("Blade Dance",nil,200685)
		lib.CDadd("Vengeful Retreat")
		lib.CDadd("Fel Rush")
		-- lib.CDAddCleave("Immolation Aura",nil,187727,178741) -- 187727
		lib.CDadd("Sigil of Flame")
		-- lib.CDAddCleave("Infernal Strike",nil,189112,189111)
		-- lib.CDAddCleave("Fel Devastation")
		lib.CDadd("Infernal Strike")
		lib.CDadd("Fel Devastation")
		--lib.CDadd("Throw Glaive")
		lib.CDadd("Fel Barrage")
		lib.CDadd("The Hunt")
		--lib.CDadd("Immolation Aura")
		
	end
end
end
